Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
MovingPartBase Class Referenceabstract

This is the base class for a single animatable piece that may be bound to one channel (or more, if blending is in effect). More...

`#include "movingPartBase.h"`

Inheritance diagram for MovingPartBase:

## Public Member Functions
| MovingPartBase (PartGroup *parent, const std::string &name)
virtual bool | clear_forced_channel ()
| Undoes the effect of a previous call to apply_freeze() or apply_control().
virtual int | complete_pointers (TypedWritable **plist, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
virtual bool | do_update (PartBundle *root, const CycleData *root_cdata, PartGroup *parent, bool parent_changed, bool anim_changed, Thread *current_thread)
| Recursively update this particular part and all of its descendents for the current frame.
virtual TypeHandle | force_init_type ()
virtual void | get_blend_value (const PartBundle *root)=0
AnimChannelBase * | get_bound (int n) const
| Returns the nth bound channel on this PartGroup.
virtual AnimChannelBase * | get_forced_channel () const
| Returns the AnimChannelBase that has been forced to this joint by a previous call to apply_freeze() or apply_control(), or NULL if no such channel has been applied.
int | get_max_bound () const
| Returns the number of channels that might be bound to this PartGroup.
virtual TypeHandle | get_type () const
virtual TypeHandle | get_value_type () const =0
| Returns the TypeHandle associated with the ValueType we are concerned with.
virtual AnimChannelBase * | make_default_channel () const =0
virtual void | output_value (std::ostream &out) const =0
virtual bool | update_internals (PartBundle *root, PartGroup *parent, bool self_changed, bool parent_changed, Thread *current_thread)
| This is called by do_update() whenever the part or some ancestor has changed values.
virtual void | write (std::ostream &out, int indent_level) const
| Writes a brief description of the channel and all of its descendants.
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
virtual void | write_with_value (std::ostream &out, int indent_level) const
| Writes a brief description of the channel and all of its descendants, along with their values.
Public Member Functions inherited from PartGroup
| PartGroup (PartGroup *parent, const std::string &name)
| Creates the PartGroup, and adds it to the indicated parent.
virtual bool | apply_control (PandaNode *node)
| Specifies a node to influence this particular joint so that it will always hold the node's transform.
bool | apply_freeze (const TransformState *transform)
| Freezes this particular joint so that it will always hold the specified transform.
virtual bool | apply_freeze_matrix (const LVecBase3 &pos, const LVecBase3 &hpr, const LVecBase3 &scale)
| Freezes this particular joint so that it will always hold the specified transform.
virtual bool | apply_freeze_scalar (PN_stdfloat value)
| Freezes this particular joint so that it will always hold the specified transform.
bool | check_hierarchy (const AnimGroup *anim, const PartGroup *parent, int hierarchy_match_flags=0) const
| Walks the part hierarchy in tandem with the indicated anim hierarchy, and returns true if the hierarchies match, false otherwise.
PartGroup * | copy_subgraph () const
| Allocates and returns a new copy of this node and of all of its children.
virtual void | do_xform (const LMatrix4 &mat, const LMatrix4 &inv_mat)
| Called by PartBundle::xform(), this indicates the indicated transform is being applied to the root joint.
PartGroup * | find_child (const std::string &name) const
| Returns the first descendant found with the indicated name, or NULL if no such descendant exists.
PartGroup * | get_child (int n) const
PartGroup * | get_child_named (const std::string &name) const
| Returns the first child found with the indicated name, or NULL if no such child exists.
int | get_num_children () const
virtual bool | is_character_joint () const
| Returns true if this part is a CharacterJoint, false otherwise.
virtual PartGroup * | make_copy () const
| Allocates and returns a new copy of the node.
void | sort_descendants ()
| Sorts the children nodes at each level of the hierarchy into alphabetical order.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from PartGroup
static TypeHandle | get_class_type ()
static void | init_type ()
static TypedWritable * | make_PartGroup (const FactoryParams &params)
| Factory method to generate a PartGroup object.
static void | register_with_read_factory ()
| Factory method to generate a PartGroup object.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Types inherited from PartGroup
enum | HierarchyMatchFlags { HMF_ok_part_extra = 0x01 , HMF_ok_anim_extra = 0x02 , HMF_ok_wrong_root_name = 0x04 }
Public Attributes inherited from PartGroup
| get_child
| Returns the nth child of the group.
| get_num_children
| Returns the number of child nodes of the group.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from Namable
| get_name
| set_name
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This is the base class for a single animatable piece that may be bound to one channel (or more, if blending is in effect).

It corresponds to, for instance, a single joint or slider of a character.

MovingPartBase does not have a particular value type. See the derived template class, MovingPart, for this.

Definition at line 31 of file movingPartBase.h.

## Constructor & Destructor Documentation

## ◆ MovingPartBase()

MovingPartBase::MovingPartBase | ( | PartGroup * | parent,
|  | const std::string & | name )

Definition at line 28 of file movingPartBase.cxx.

## Member Function Documentation

## ◆ clear_forced_channel()

bool MovingPartBase::clear_forced_channel | ( |  | ) |
| virtual

Undoes the effect of a previous call to apply_freeze() or apply_control().

Returns true if the joint was modified, false otherwise.

Reimplemented from PartGroup.

Definition at line 50 of file movingPartBase.cxx.

## ◆ complete_pointers()

int MovingPartBase::complete_pointers | ( | TypedWritable ** | p_list,
|  | BamReader * | manager )
| virtual

Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().

Returns the number of pointers processed.

This is the callback function that is made by the BamReader at some later point, after all of the required pointers have been filled in. It is necessary because there might be forward references in a bam file; when we call read_pointer() in fillin(), the object may not have been read from the file yet, so we do not have a pointer available at that time. Thus, instead of returning a pointer, read_pointer() simply reserves a later callback. This function provides that callback. The calling object is responsible for keeping track of the number of times it called read_pointer() and extracting the same number of pointers out of the supplied vector, and storing them appropriately within the object.

Reimplemented from PartGroup.

Reimplemented in CharacterJoint.

Definition at line 365 of file movingPartBase.cxx.

References PartGroup::complete_pointers(), and BamReader::get_file_minor_ver().

Referenced by CharacterJoint::complete_pointers().

## ◆ do_update()

bool MovingPartBase::do_update | ( | PartBundle * | root,
|  | const CycleData * | root_cdata,
|  | PartGroup * | parent,
|  | bool | parent_changed,
|  | bool | anim_changed,
|  | Thread * | current_thread )
| virtual

Recursively update this particular part and all of its descendents for the current frame.

This is not really public and is not intended to be called directly; it is called from the top of the tree by PartBundle::update().

The return value is true if any part has changed, false otherwise.

Reimplemented from PartGroup.

Definition at line 110 of file movingPartBase.cxx.

References AnimControl::channel_has_changed(), AnimControl::get_channel_index(), and update_internals().

## ◆ force_init_type()

virtual TypeHandle MovingPartBase::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from PartGroup.

Definition at line 107 of file movingPartBase.h.

## ◆ get_blend_value()

virtual void MovingPartBase::get_blend_value | ( | const PartBundle * | root | ) |
| pure virtual

Implemented in MovingPartMatrix, and MovingPartScalar.

## ◆ get_bound()

AnimChannelBase * MovingPartBase::get_bound | ( | int | n | ) | const
| inline

Returns the nth bound channel on this PartGroup.

n can be determined by iterating from 0 to one less than get_max_bound(); or n might be AnimControl::get_channel_index().

This will return NULL if there is no channel bound on the indicated index. It is an error to call this if n is less than zero or greater than or equal to get_max_bound().

Definition at line 48 of file movingPartBase.I.

## ◆ get_class_type()

static TypeHandle MovingPartBase::get_class_type | ( |  | ) |
| inline static

Definition at line 109 of file movingPartBase.h.

## ◆ get_forced_channel()

AnimChannelBase * MovingPartBase::get_forced_channel | ( |  | ) | const
| virtual

Returns the AnimChannelBase that has been forced to this joint by a previous call to apply_freeze() or apply_control(), or NULL if no such channel has been applied.

Reimplemented from PartGroup.

Definition at line 64 of file movingPartBase.cxx.

## ◆ get_max_bound()

int MovingPartBase::get_max_bound | ( |  | ) | const
| inline

Returns the number of channels that might be bound to this PartGroup.

This might not be the actual number of channels, since there might be holes in the list; it is one more than the index number of the highest bound channel. Thus, it is called get_max_bound() instead of get_num_bound().

Definition at line 34 of file movingPartBase.I.

## ◆ get_type()

virtual TypeHandle MovingPartBase::get_type | ( |  | ) | const
| inline virtual

Reimplemented from PartGroup.

Definition at line 104 of file movingPartBase.h.

## ◆ get_value_type()

virtual TypeHandle MovingPartBase::get_value_type | ( |  | ) | const
| pure virtual

Returns the TypeHandle associated with the ValueType we are concerned with.

This is provided to allow a bit of run-time checking that joints and channels are matching properly in type.

Reimplemented from PartGroup.

Implemented in MovingPart< SwitchType >, MovingPart< ACMatrixSwitchType >, and MovingPart< ACScalarSwitchType >.

References update_internals().

Referenced by write(), and write_with_value().

## ◆ init_type()

static void MovingPartBase::init_type | ( |  | ) |
| inline static

Definition at line 113 of file movingPartBase.h.

## ◆ make_default_channel()

virtual AnimChannelBase * MovingPartBase::make_default_channel | ( |  | ) | const
| pure virtual

Implemented in MovingPart< SwitchType >, MovingPart< ACMatrixSwitchType >, MovingPart< ACScalarSwitchType >, and MovingPartMatrix.

## ◆ output_value()

virtual void MovingPartBase::output_value | ( | std::ostream & | out | ) | const
| pure virtual

Implemented in MovingPart< SwitchType >, MovingPart< ACMatrixSwitchType >, and MovingPart< ACScalarSwitchType >.

## ◆ update_internals()

bool MovingPartBase::update_internals | ( | PartBundle * | root,
|  | PartGroup * | parent,
|  | bool | self_changed,
|  | bool | parent_changed,
|  | Thread * | current_thread )
| virtual

This is called by do_update() whenever the part or some ancestor has changed values.

It is a hook for derived classes to update whatever cache they may have that depends on these.

The return value is true if the part has changed as a result of the update, or false otherwise.

Reimplemented in CharacterJoint, and CharacterSlider.

Definition at line 179 of file movingPartBase.cxx.

Referenced by do_update(), and get_value_type().

## ◆ write()

void MovingPartBase::write | ( | std::ostream & | out,
|  | int | indent_level ) const
| virtual

Writes a brief description of the channel and all of its descendants.

Reimplemented from PartGroup.

Definition at line 72 of file movingPartBase.cxx.

References get_value_type(), and indent().

## ◆ write_datagram()

void MovingPartBase::write_datagram | ( | BamWriter * | manager,
|  | Datagram & | dg )
| virtual

Writes the contents of this object to the datagram for shipping out to a Bam file.

Reimplemented from PartGroup.

Reimplemented in CharacterJoint, MovingPart< SwitchType >, MovingPart< ACMatrixSwitchType >, and MovingPart< ACScalarSwitchType >.

Definition at line 343 of file movingPartBase.cxx.

References PartGroup::write_datagram(), and BamWriter::write_pointer().

Referenced by CharacterJoint::write_datagram(), and MovingPart< SwitchType >::write_datagram().

## ◆ write_with_value()

void MovingPartBase::write_with_value | ( | std::ostream & | out,
|  | int | indent_level ) const
| virtual

Writes a brief description of the channel and all of its descendants, along with their values.

Reimplemented from PartGroup.

Definition at line 88 of file movingPartBase.cxx.

References get_value_type(), and indent().

The documentation for this class was generated from the following files:

- panda/src/chan/movingPartBase.h
- panda/src/chan/movingPartBase.cxx
- panda/src/chan/movingPartBase.I